$regfile = "m8def.dat"
$crystal = 8000000

Dim I As Integer
Dim Cd As String * 9
Dim Line1 As String * 16
Dim Line2 As String * 16
Dim Lock As Bit
Dim V As Word

Declare Sub Getrnd()
Declare Sub Showrnd()
Declare Sub Testbattery()

Config Adc = Single , Prescaler = Auto
Config Lcdpin = Pin , Rs = Portb.0 , E = Portb.1 , Db4 = Portb.2 , Db5 = Portb.3 , Db6 = Portb.4 , Db7 = Portb.5
Config Lcd = 16 * 2
Config Lcdmode = Port

Config Portd.2 = Input                                      '  ""
Config Portd.3 = Input                                      '  
Config Portd.4 = Output                                     '  LCD 

Config Portb.0 = Output
Config Portb.1 = Output
Config Portb.2 = Output
Config Portb.3 = Output
Config Portb.4 = Output
Config Portb.5 = Output


Config Int0 = Falling                                       '   i  
On Int0 Int0_int

Config Int1 = Rising                                        '     
On Int1 Int1_int


Start Adc
V = Getadc(0)

Set Portd.4
Lock = 0

Deflcdchar 0 , 14 , 27 , 21 , 21 , 17 , 21 , 17 , 31        '     
Deflcdchar 1 , 14 , 17 , 1 , 2 , 1 , 17 , 14 , 32           '  
Deflcdchar 2 , 17 , 19 , 19 , 21 , 25 , 25 , 17 , 32        '  
Deflcdchar 3 , 31 , 16 , 16 , 30 , 17 , 17 , 30 , 32        '  
Deflcdchar 4 , 18 , 21 , 21 , 29 , 21 , 21 , 18 , 32        '  

If V < 1000 Then
   Cls
   Lcd Chr(0) ; "              " ; Chr(0)
   Lowerline
   Lcd Chr(1) ; "AMEH" ; Chr(2) ; "TE " ; Chr(3) ; "ATAPE" ; Chr(4)
   End
End If

Deflcdchar 0 , 14 , 17 , 1 , 7 , 1 , 17 , 14 , 32           '  
Deflcdchar 1 , 7 , 9 , 9 , 9 , 9 , 9 , 17 , 32              '  
Deflcdchar 2 , 15 , 17 , 17 , 15 , 5 , 9 , 17 , 32          '  
Deflcdchar 3 , 31 , 17 , 17 , 17 , 17 , 17 , 17 , 32        '  
Deflcdchar 4 , 31 , 16 , 16 , 30 , 17 , 17 , 30 , 32        '  
'----------------
'|   |
'| ver.1.0|
'----------------
Cls
Cursor Off
Lcd Chr(0) ; Chr(1) ; "EKTPOHHA" ; Chr(2)
Lowerline
Lcd Chr(3) ; Chr(1) ; "OM" ; Chr(4) ; "A   ver.1.0"
Wait 2


Enable Int0
Enable Int1

Call Getrnd()

If Pind.3 = 1 Then Lock = 0 Else Lock = 1

Do
Set Portd.4
Call Testbattery()
Cls
Waitms 10
Call Showrnd()
Wait 5
Cls
Reset Portd.4
Enable Interrupts
Idle
Loop


Sub Getrnd()                                                '  
Lock = 1
Cd = Str(rnd(9)) + Str(rnd(9)) + Str(rnd(9)) + Str(rnd(9)) + Str(rnd(9)) + Str(rnd(9)) + Str(rnd(9)) + Str(rnd(9))

End Sub

Sub Showrnd()
Waitms 100
Cls
Waitms 100                                                  '     LCD
Locate 1 , 1
Waitms 100
Lcd Cd
Waitms 100
End Sub

Sub Testbattery()                                           '   
Start Adc
V = Getadc(0)
Stop Adc
If V < 1000 Then
Set Portd.4
Deflcdchar 0 , 14 , 27 , 21 , 21 , 17 , 21 , 17 , 31        '     
Deflcdchar 1 , 14 , 17 , 1 , 2 , 1 , 17 , 14 , 32           '  
Deflcdchar 2 , 17 , 19 , 19 , 21 , 25 , 25 , 17 , 32        '  
Deflcdchar 3 , 31 , 16 , 16 , 30 , 17 , 17 , 30 , 32        '  
Deflcdchar 4 , 18 , 21 , 21 , 29 , 21 , 21 , 18 , 32        '  
Cls
Upperline
Lcd Chr(0) ; "              " ; Chr(0)
Lowerline
Lcd Chr(1) ; "AMEH" ; Chr(2) ; "TE " ; Chr(3) ; "ATAPE" ; Chr(4)
Wait 2
Else
Set Portd.4
End If
End Sub

Int0_int:
Disable Interrupts                                          '   i  
Return

Int1_int:                                                   '     
Disable Interrupts
Call Getrnd()
Return

End